<?php
/**
 * Created by PhpStorm.
 * User: felipesantos
 * Date: 12/09/2017
 * Time: 17:40
 */

namespace Service\Hcm;

class FinanceiroService {

    private $entityManager;

    public function __construct(\Doctrine\ORM\EntityManager $entityManager)
    {
        $this->entityManager = $entityManager;
    }

    public function getAssociacaoFinanceira($nrorg, $cdcnpjParceiro, $cdTpCtPagar){
        try {
            $query = <<<SQL
SELECT IP.*, PN.NRINSCRICAOPARC, PN.NMPRINCIPALPARC
  FROM FPA_INCIDEPARCPAGAR IP
  JOIN PARCNEGOCIO PN ON PN.NRORG = IP.NRORG
                     AND PN.NRPARCNEGOCIO = IP.NRPARCNEGOCIO
  JOIN TIPOCTPAGAR TC ON TC.NRORG = IP.NRORG
                     AND TC.CDTPCTPAGAR = IP.CDTPCTPAGAR
  JOIN FPA_TIPOINCIDE TI ON TI.NRTIPOINCIDE = IP.NRTIPOINCIDE
 WHERE IP.NRORG = :P_NRORG
   AND (PN.NRINSCRICAOPARC = :P_CDCNPJPARCEIRO OR :P_CDCNPJPARCEIRO IS NULL)
   AND (TC.CDTPCTPAGAR = :P_CDTPCTPAGAR OR :P_CDTPCTPAGAR IS NULL)
   AND (:P_CDCNPJPARCEIRO IS NOT NULL OR :P_CDTPCTPAGAR IS NOT NULL)
SQL;
            $params = array(
                'P_NRORG' => $nrorg,
                'P_CDCNPJPARCEIRO' => $cdcnpjParceiro,
                'P_CDTPCTPAGAR' => $cdTpCtPagar,
            );

            return $this->entityManager->getConnection()->fetchAssoc($query, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }
}